unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, StdCtrls, ComCtrls, Dialogs;

type
  { TMyThread }
  TMyThread = class(TThread)
  private
    fStatusText : string;
    procedure ShowStatus;
  protected
    procedure Execute; override;
  public
    Constructor Create(CreateSuspended : boolean);
  end;

  { TFrame1 }
  TFrame1 = class(TFrame)
    Button1: TButton;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure OnThreadDone(Sender: TObject);
  private
    IsThreadRunning: boolean;
  public
    MyThread: TMyThread;
  end;

implementation

{$R *.lfm}

{ TFrame1 }
procedure TFrame1.Button1Click(Sender: TObject);
begin
  if (not IsThreadRunning) then
  begin
    MyThread := TMyThread.Create(True);
    MyThread.OnTerminate := @OnThreadDone;
    MyThread.Start;
    IsThreadRunning := true;
    Button1.Caption := 'Stop'
  end
  else
  begin
    MyThread.Terminate;
    Button1.Caption := 'Start';
  end;
  Application.ProcessMessages;
end;

procedure TFrame1.OnThreadDone(Sender: TObject);
begin
  IsThreadRunning := false;
  ShowMessage('TMyThread Stopped');
end;

constructor TMyThread.Create(CreateSuspended : boolean);
begin
  inherited Create(CreateSuspended);
  FreeOnTerminate := True;
end;

procedure TMyThread.ShowStatus;
// this method is executed by the mainthread and can therefore access all GUI elements.
begin
  // Hier soll der Timer innerhalb des Frames in der Statusbar angezeigt werden
  //TFrame1.StatusBar1.SimpleText := fStatusText;         // Compilierung n.i.O.
  //Form1.TFrame1_1.StatusBar1.SimpleText := fStatusText; // Compilierung n.i.O.
  //Application.Title := fStatusText; // compiliert i.O. aber setzt den Timer in das ShowMessage Fenster Ende des Threads
                                      // es soll aber in die StatusBar1 des Frames!
end;

procedure TMyThread.Execute;
var
  newStatus : string;
begin
  fStatusText := 'TMyThread Starting...';
  Synchronize(@Showstatus);
  fStatusText := 'TMyThread Running...';
  while (not Terminated) do
  begin
    NewStatus := 'TMyThread Timer: ' + FormatDateTime('HH:NN:SS', Now);
    if NewStatus <> fStatusText then
    begin
      fStatusText := newStatus;
      Synchronize(@Showstatus);
    end;
  end;
end;

end.

